/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __GNOME_SESSION_MANAGER_H__
#define __GNOME_SESSION_MANAGER_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.gnome.SessionManager */

#define TYPE_GNOME_SESSION_MANAGER (gnome_session_manager_get_type ())
#define GNOME_SESSION_MANAGER(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), TYPE_GNOME_SESSION_MANAGER, GnomeSessionManager))
#define IS_GNOME_SESSION_MANAGER(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), TYPE_GNOME_SESSION_MANAGER))
#define GNOME_SESSION_MANAGER_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), TYPE_GNOME_SESSION_MANAGER, GnomeSessionManagerIface))

struct _GnomeSessionManager;
typedef struct _GnomeSessionManager GnomeSessionManager;
typedef struct _GnomeSessionManagerIface GnomeSessionManagerIface;

struct _GnomeSessionManagerIface
{
  GTypeInterface parent_iface;



  gboolean (*handle_can_shutdown) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_get_clients) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_get_inhibitors) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_get_locale) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    gint arg_category);

  gboolean (*handle_inhibit) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_app_id,
    guint arg_toplevel_xid,
    const gchar *arg_reason,
    guint arg_flags);

  gboolean (*handle_initialization_error) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_message,
    gboolean arg_fatal);

  gboolean (*handle_is_autostart_condition_handled) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_condition);

  gboolean (*handle_is_inhibited) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    guint arg_flags);

  gboolean (*handle_is_session_running) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_logout) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    guint arg_mode);

  gboolean (*handle_reboot) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_register_client) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_app_id,
    const gchar *arg_client_startup_id);

  gboolean (*handle_setenv) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_variable,
    const gchar *arg_value);

  gboolean (*handle_shutdown) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_uninhibit) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    guint arg_inhibit_cookie);

  gboolean (*handle_unregister_client) (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_client_id);

  guint  (*get_inhibited_actions) (GnomeSessionManager *object);

  gboolean  (*get_session_is_active) (GnomeSessionManager *object);

  const gchar * (*get_session_name) (GnomeSessionManager *object);

  void (*client_added) (
    GnomeSessionManager *object,
    const gchar *arg_id);

  void (*client_removed) (
    GnomeSessionManager *object,
    const gchar *arg_id);

  void (*inhibitor_added) (
    GnomeSessionManager *object,
    const gchar *arg_id);

  void (*inhibitor_removed) (
    GnomeSessionManager *object,
    const gchar *arg_id);

  void (*session_over) (
    GnomeSessionManager *object);

  void (*session_running) (
    GnomeSessionManager *object);

};

GType gnome_session_manager_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *gnome_session_manager_interface_info (void);
guint gnome_session_manager_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void gnome_session_manager_complete_setenv (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

void gnome_session_manager_complete_get_locale (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *value);

void gnome_session_manager_complete_initialization_error (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

void gnome_session_manager_complete_register_client (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *client_id);

void gnome_session_manager_complete_unregister_client (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

void gnome_session_manager_complete_inhibit (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    guint inhibit_cookie);

void gnome_session_manager_complete_uninhibit (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

void gnome_session_manager_complete_is_inhibited (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    gboolean is_inhibited);

void gnome_session_manager_complete_get_clients (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *clients);

void gnome_session_manager_complete_get_inhibitors (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *inhibitors);

void gnome_session_manager_complete_is_autostart_condition_handled (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    gboolean handled);

void gnome_session_manager_complete_shutdown (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

void gnome_session_manager_complete_reboot (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

void gnome_session_manager_complete_can_shutdown (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    gboolean is_available);

void gnome_session_manager_complete_logout (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation);

void gnome_session_manager_complete_is_session_running (
    GnomeSessionManager *object,
    GDBusMethodInvocation *invocation,
    gboolean running);



/* D-Bus signal emissions functions: */
void gnome_session_manager_emit_client_added (
    GnomeSessionManager *object,
    const gchar *arg_id);

void gnome_session_manager_emit_client_removed (
    GnomeSessionManager *object,
    const gchar *arg_id);

void gnome_session_manager_emit_inhibitor_added (
    GnomeSessionManager *object,
    const gchar *arg_id);

void gnome_session_manager_emit_inhibitor_removed (
    GnomeSessionManager *object,
    const gchar *arg_id);

void gnome_session_manager_emit_session_running (
    GnomeSessionManager *object);

void gnome_session_manager_emit_session_over (
    GnomeSessionManager *object);



/* D-Bus method calls: */
void gnome_session_manager_call_setenv (
    GnomeSessionManager *proxy,
    const gchar *arg_variable,
    const gchar *arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_setenv_finish (
    GnomeSessionManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_setenv_sync (
    GnomeSessionManager *proxy,
    const gchar *arg_variable,
    const gchar *arg_value,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_get_locale (
    GnomeSessionManager *proxy,
    gint arg_category,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_get_locale_finish (
    GnomeSessionManager *proxy,
    gchar **out_value,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_get_locale_sync (
    GnomeSessionManager *proxy,
    gint arg_category,
    gchar **out_value,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_initialization_error (
    GnomeSessionManager *proxy,
    const gchar *arg_message,
    gboolean arg_fatal,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_initialization_error_finish (
    GnomeSessionManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_initialization_error_sync (
    GnomeSessionManager *proxy,
    const gchar *arg_message,
    gboolean arg_fatal,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_register_client (
    GnomeSessionManager *proxy,
    const gchar *arg_app_id,
    const gchar *arg_client_startup_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_register_client_finish (
    GnomeSessionManager *proxy,
    gchar **out_client_id,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_register_client_sync (
    GnomeSessionManager *proxy,
    const gchar *arg_app_id,
    const gchar *arg_client_startup_id,
    gchar **out_client_id,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_unregister_client (
    GnomeSessionManager *proxy,
    const gchar *arg_client_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_unregister_client_finish (
    GnomeSessionManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_unregister_client_sync (
    GnomeSessionManager *proxy,
    const gchar *arg_client_id,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_inhibit (
    GnomeSessionManager *proxy,
    const gchar *arg_app_id,
    guint arg_toplevel_xid,
    const gchar *arg_reason,
    guint arg_flags,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_inhibit_finish (
    GnomeSessionManager *proxy,
    guint *out_inhibit_cookie,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_inhibit_sync (
    GnomeSessionManager *proxy,
    const gchar *arg_app_id,
    guint arg_toplevel_xid,
    const gchar *arg_reason,
    guint arg_flags,
    guint *out_inhibit_cookie,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_uninhibit (
    GnomeSessionManager *proxy,
    guint arg_inhibit_cookie,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_uninhibit_finish (
    GnomeSessionManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_uninhibit_sync (
    GnomeSessionManager *proxy,
    guint arg_inhibit_cookie,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_is_inhibited (
    GnomeSessionManager *proxy,
    guint arg_flags,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_is_inhibited_finish (
    GnomeSessionManager *proxy,
    gboolean *out_is_inhibited,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_is_inhibited_sync (
    GnomeSessionManager *proxy,
    guint arg_flags,
    gboolean *out_is_inhibited,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_get_clients (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_get_clients_finish (
    GnomeSessionManager *proxy,
    gchar ***out_clients,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_get_clients_sync (
    GnomeSessionManager *proxy,
    gchar ***out_clients,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_get_inhibitors (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_get_inhibitors_finish (
    GnomeSessionManager *proxy,
    gchar ***out_inhibitors,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_get_inhibitors_sync (
    GnomeSessionManager *proxy,
    gchar ***out_inhibitors,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_is_autostart_condition_handled (
    GnomeSessionManager *proxy,
    const gchar *arg_condition,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_is_autostart_condition_handled_finish (
    GnomeSessionManager *proxy,
    gboolean *out_handled,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_is_autostart_condition_handled_sync (
    GnomeSessionManager *proxy,
    const gchar *arg_condition,
    gboolean *out_handled,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_shutdown (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_shutdown_finish (
    GnomeSessionManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_shutdown_sync (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_reboot (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_reboot_finish (
    GnomeSessionManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_reboot_sync (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_can_shutdown (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_can_shutdown_finish (
    GnomeSessionManager *proxy,
    gboolean *out_is_available,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_can_shutdown_sync (
    GnomeSessionManager *proxy,
    gboolean *out_is_available,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_logout (
    GnomeSessionManager *proxy,
    guint arg_mode,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_logout_finish (
    GnomeSessionManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_logout_sync (
    GnomeSessionManager *proxy,
    guint arg_mode,
    GCancellable *cancellable,
    GError **error);

void gnome_session_manager_call_is_session_running (
    GnomeSessionManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gnome_session_manager_call_is_session_running_finish (
    GnomeSessionManager *proxy,
    gboolean *out_running,
    GAsyncResult *res,
    GError **error);

gboolean gnome_session_manager_call_is_session_running_sync (
    GnomeSessionManager *proxy,
    gboolean *out_running,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
const gchar *gnome_session_manager_get_session_name (GnomeSessionManager *object);
gchar *gnome_session_manager_dup_session_name (GnomeSessionManager *object);
void gnome_session_manager_set_session_name (GnomeSessionManager *object, const gchar *value);

gboolean gnome_session_manager_get_session_is_active (GnomeSessionManager *object);
void gnome_session_manager_set_session_is_active (GnomeSessionManager *object, gboolean value);

guint gnome_session_manager_get_inhibited_actions (GnomeSessionManager *object);
void gnome_session_manager_set_inhibited_actions (GnomeSessionManager *object, guint value);


/* ---- */

#define TYPE_GNOME_SESSION_MANAGER_PROXY (gnome_session_manager_proxy_get_type ())
#define GNOME_SESSION_MANAGER_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), TYPE_GNOME_SESSION_MANAGER_PROXY, GnomeSessionManagerProxy))
#define GNOME_SESSION_MANAGER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), TYPE_GNOME_SESSION_MANAGER_PROXY, GnomeSessionManagerProxyClass))
#define GNOME_SESSION_MANAGER_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TYPE_GNOME_SESSION_MANAGER_PROXY, GnomeSessionManagerProxyClass))
#define IS_GNOME_SESSION_MANAGER_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), TYPE_GNOME_SESSION_MANAGER_PROXY))
#define IS_GNOME_SESSION_MANAGER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), TYPE_GNOME_SESSION_MANAGER_PROXY))

typedef struct _GnomeSessionManagerProxy GnomeSessionManagerProxy;
typedef struct _GnomeSessionManagerProxyClass GnomeSessionManagerProxyClass;
typedef struct _GnomeSessionManagerProxyPrivate GnomeSessionManagerProxyPrivate;

struct _GnomeSessionManagerProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  GnomeSessionManagerProxyPrivate *priv;
};

struct _GnomeSessionManagerProxyClass
{
  GDBusProxyClass parent_class;
};

GType gnome_session_manager_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnomeSessionManagerProxy, g_object_unref)
#endif

void gnome_session_manager_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
GnomeSessionManager *gnome_session_manager_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
GnomeSessionManager *gnome_session_manager_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void gnome_session_manager_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
GnomeSessionManager *gnome_session_manager_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
GnomeSessionManager *gnome_session_manager_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define TYPE_GNOME_SESSION_MANAGER_SKELETON (gnome_session_manager_skeleton_get_type ())
#define GNOME_SESSION_MANAGER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), TYPE_GNOME_SESSION_MANAGER_SKELETON, GnomeSessionManagerSkeleton))
#define GNOME_SESSION_MANAGER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), TYPE_GNOME_SESSION_MANAGER_SKELETON, GnomeSessionManagerSkeletonClass))
#define GNOME_SESSION_MANAGER_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TYPE_GNOME_SESSION_MANAGER_SKELETON, GnomeSessionManagerSkeletonClass))
#define IS_GNOME_SESSION_MANAGER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), TYPE_GNOME_SESSION_MANAGER_SKELETON))
#define IS_GNOME_SESSION_MANAGER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), TYPE_GNOME_SESSION_MANAGER_SKELETON))

typedef struct _GnomeSessionManagerSkeleton GnomeSessionManagerSkeleton;
typedef struct _GnomeSessionManagerSkeletonClass GnomeSessionManagerSkeletonClass;
typedef struct _GnomeSessionManagerSkeletonPrivate GnomeSessionManagerSkeletonPrivate;

struct _GnomeSessionManagerSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  GnomeSessionManagerSkeletonPrivate *priv;
};

struct _GnomeSessionManagerSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType gnome_session_manager_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnomeSessionManagerSkeleton, g_object_unref)
#endif

GnomeSessionManager *gnome_session_manager_skeleton_new (void);


G_END_DECLS

#endif /* __GNOME_SESSION_MANAGER_H__ */
